//
#pragma once

#include "utils.h"
#include "acl/acl.h"
#include "fcos_parameters.h"
#include "model_process.h"

class Fcos3dPipeline
{
public:
    Fcos3dPipeline();

    /**
     * @brief Destructor
     */
    virtual ~Fcos3dPipeline();

    Result Init(const Fcos3dInitParams &fcos3DInitParams);

    Result Process();

    PredOut<float> &GetFinalResults() 
    {
        return final_results_;
    }
    std::vector<PredOut<float>> &GetAllResults() 
    {
        return all_results_;
    }

private:
    bool ParseConfigFile(const std::string &config_file);

    void DestroyResource();

    PredOut<float> final_results_;
    std::vector<PredOut<float>> all_results_; // To store final_results_ for each iteration
    int32_t deviceId_;
    aclrtContext context_;
    aclrtStream stream_;
    Fcos3dConstantParameter fcos3DConstantParameter;
    ModelProcess modelProcess;
};
